
var g = [
	[0,0,0,0,0],
	[0,0,0,0,0],
	[0,1,0,-1,0],
	[0,0,0,0,0],
	[0,0,0,0,0] 
];

console.log("Position :");
console.log (toStringBW(g).toUpperCase());
console.log("\n");
console.log("Influence :");
console.log (toStringBW(zorbist(g),g));
console.log("\n");
console.log (toStringNum(zorbist(g)));


function zorbist(a) {
	var r = init(g);
	var nbIteration = 4;

	for (var i = 0;i< nbIteration;i++) {
		r = z(r);
	}
	return r;
}

function init(a) {
	var size_y =  a.length;
	var size_x =  a[0].length;
	var r = [];
	for (var y = 0;y < size_y; y ++) {
		r[y] = [];
		for (var x = 0;x < size_x; x ++) {
			r[y][x] = g[y][x] * 50;
		}
	}
	return r;
}

/*
 * Compute an "array" of score  for a game position
 */
function z(a) {
	var size_y =  a.length;
	var size_x =  a[0].length;
	var r = [];
	for (var y = 0;y < size_y; y ++) {
		r[y] = [];
		for (var x = 0;x < size_x; x ++) {
			var top =    {pos:"top", x : x,	y : y-1};
			var bottom = {pos:"bottom", x : x,	y : y+1};
			var left =   {pos:"left", x : x-1,	y : y};
			var right =  {pos:"right", x : x+1,	y : y};
			
			var onBoardNearPos = keepPositionsOnBoardOnly(size_x, size_y,[top,bottom,left,right]);
			var score = a[y][x];

			for (var i = 0;i < onBoardNearPos.length ; i++) {
				var pos = onBoardNearPos[i];
				if ( a[pos.y][pos.x] > 0) {
					score ++;
				} else if ( a[pos.y][pos.x] < 0) {
					score --;
				}
			}
			r[y][x] = score;
		}
	}
	return r;
}

function keepPositionsOnBoardOnly(size_x, size_y, a) {
	var r = [];
	for (var i = 0;i < a.length ; i++) {
		var x = a[i].x;
		var y = a[i].y;
		if ((x >= 0) && (y>=0) && (x < size_x) &&  (y < size_y)) {
			r.push(a[i]);
		}
	}
	return r;
}

/*
 * a few rendering functions...
 */
function centerString ( str, width ) {
	var padding = " ";
	padding = padding.substr( 0, 1 );
	if( str.length < width ) {
		var len		= width - str.length;
		var remain	= ( len % 2 === 0 ) ? "" : padding;
		var pads="";
		for (var i = 0;i < parseInt( len / 2 , 10);i++){
			pads = pads + padding;
		}
		return pads + str + pads + remain;
	} else {
		return str;
	}
}
function toStringNum(a) {
	var size_y =  a.length;
	var size_x =  a[0].length;
	var r = "";
	for (var y = 0; y < size_y; y ++) {
		for (var x = 0; x < size_x; x ++) {
			var v = a[y][x].toString();
			r += centerString(v,5);
		}
		r +="\n";
	}
	return "\n"+r;
}
function toStringBW(a,g) {
	var size_y =  a.length;
	var size_x =  a[0].length;
	var r = "";
	for (var y = 0; y < size_y; y ++) {
		for (var x = 0; x < size_x; x ++) {
			var v = a[y][x];
			if (v > 0) {
				if (g && (g[y][x] == 1)) {
					r +="X ";
				} else {
					r +="x ";
				}
			} else if (v < 0){
				if (g && (g[y][x] == -1)) {
					r +="O ";
				} else {
					r +="o ";
				}
			} else {
				r +=". ";
			}
		}
		r +="\n";
	}
	return "\n"+r;
}


